#include<bits/stdc++.h>
#define B 750
using namespace std;
int n,q;
int fa[500010][23],dep[500010];
int lc[5010][5010],lc1[5010][5010];
int dk[810][810],lst[500010],nxt[500010];

int tot,head[1000010];
struct edge {
	int nex;
	int to;
} e[2000010];

void add(int x,int y) {
	tot++;
	e[tot].nex=head[x];
	e[tot].to=y;
	head[x]=tot;
}

bool vis[500010];
void dfs(int x) {
	vis[x]=1;
	for(int i=head[x]; i; i=e[i].nex) {
		int j=e[i].to;
		if(!vis[j]) {
			dep[j]=dep[x]+1;
			fa[j][0]=x;
			dfs(j);
		}
	}
}

int lca(int u,int v) {
	int l=16;
	while(dep[u]!=dep[v] && l>0) {
		l--;
		if(dep[u]<dep[v]) swap(u,v);
		if(dep[u]-(1<<l)>=dep[v])u=fa[u][l];
	}
	l=16;
	while(u!=v && l>0) {
		l--;
		if(fa[u][l]!=fa[v][l] || l==0) u=fa[u][l],v=fa[v][l];
	}
	if(u!=v) u=fa[u][0],v=fa[v][0];
	return u;
}

int read()
{
	int k=0,fu=1;
	char ch=getchar();
	while(ch<'0' || ch>'9')
	{
		if(ch=='-') fu=-1;
		ch=getchar();
	}
	while(ch>='0' && ch<='9')
	{
		k=k*10+ch-'0';
		ch=getchar();
	}
	return k*fu;
}

signed main() {
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	scanf("%d",&n);
	for(int i=1; i<n; i++) {
		int u,v;
		u=read(),v=read();
//		scanf("%d%d",&u,&v);
		add(u,v),add(v,u);
	}
	dep[1]=1;
	dfs(1);
	for(int j=1; j<=20; j++) for(int i=1; i<=n; i++) fa[i][j]=fa[fa[i][j-1]][j-1];
	if(n<=6000) {
		for(int i=1; i<=n; i++) lc1[i][i]=i;
		for(int len=2; len<=n; len++) {
			for(int i=1; i+len-1<=n; i++) {
				int j=i+len-1;
				lc1[i][j]=lca(lc1[i][j-1],j);
			}
		}
		scanf("%d",&q);
		for(int i=1; i<=q; i++) {
			int l,r,k;
			scanf("%d%d%d",&l,&r,&k);
			int ans=0;
			for(int j=l; j+k-1<=r; j++) {
				int p=lc1[j][j+k-1];
				ans=max(ans,dep[p]);
			}
			cout<<ans<<endl;
		}
		return 0;
	}
	int p=0;
	for(int i=1; i<=n; i++) {
		if(i%B==1) {
			p=i;
		}
		p=lca(p,i);
		lst[i]=p;
		if(i%B==0) dk[i/B][i/B]=p;
	}
	p=n;
	for(int i=n; i>=1; i--) {
		if(i%B==0) {
			p=i;
		}
		p=lca(p,i);
		nxt[i]=p;
	}
	for(int len=2; len<=750; len++) {
		for(int i=1; i+len-1<=750; i++) {
			int j=i+len-1;
			dk[i][j]=lca(dk[i][j-1],dk[j][j]);
		}
	}
	q=read();
//	scanf("%d",&q);
	for(int i=1; i<=q; i++) {
		int l,r,k;
		l=read(),r=read(),k=read();
//		scanf("%d%d%d",&l,&r,&k);
		int kl=(l-1)/B+1,kr=(r-1)/B+1;
		if(kl!=kr)
		{
			int p=dk[kl+1][kr];
			p=lca(p,nxt[l]);
			p=lca(p,lst[r]);
		}
		else
		{
			int p=l;
			for(int i=l;i<=r;i++)
			p=lca(p,i);
		}
		int ans=dep[p];
		printf("%d\n",ans);
	}
}
//g++ query.cpp -o query.exe -O2 -std=c++14
